Gradle 5.0 新特性介绍

本文翻译自官网 :https://gradle.org/whats-new/gradle-5/

Gradle 5.0是最快、最安全、功能最强的Gradle版本。

改进的增量编译和增量注释处理建立在坚实的性能基础之上,这些性能基础已经提供了构建缓存和最新的检查功能。

依赖约束、依赖对齐和版本锁定提供了可伸缩和灵活的依赖管理模型。

通过新的性能、依赖管理、日志记录和废弃的API使用检查,构建扫描有了显著的改进。

我们将最近版本中的主要改进分为以下几类:

更快的构建

细粒度的传递依赖关系管理

编写Gradle构建逻辑

更高效的内存级别执行

新的Gradle调用选项

新的Gradle任务和插件api

在文章末尾,您可以进一步了解如何升级到5.0。

更快的构建

缓慢的构建会浪费很多钱。通过使用Gradle 5.0中的新构建缓存和增量处理特性,只构建你需要的东西,

你和你的主管都会很高兴。

在升级到Gradle 5.0之后,你的构建已经快了一些,你可以通过使用和配置本节中描述的其他特性来进一步提高它们的性能。

1.Build caching

通过重用以前执行的结果来避免工作,这使得Gradle非常快。Gradle 4.0引入了构建缓存,其目的是重用以前调用Gradle时的输出。

今天,用于Android、Kotlin、c++、Scala和许多其他插件的插件使得任务可以缓存,因此可以跨不同的机器重用。有效地使用构建缓存可以将构建时间减少90%。

此外,Gradle 5.0中的构建缓存在更多的场景中也是启用的,例如当一个任务声明一个或集合时。

2.增量Java编译

在Gradle 5.0中,增量编译器是高度优化的,并且是默认开启的。

这是一个非常棒的消息,因为编译java任务不需要重新编译所有的源文件,除非你clean了项目后的第一次编译。

3.增量注解处理

5.0中的增量编译器支持增量注解处理,当有注解处理程序时,显著提高了增量编译的效率。这是一个重要的创新,因为依赖注解处理器的项目越来越多。

要利用增量注解处理,请确保升级到选择该特性的注解处理程序版本。您可以通过日志记录或在这个流行的注释处理程序表中发现给定的注释过程是否是增量的。

https://github.com/gradle/gradle/issues/5277

使用新的annotationProcessor配置可以方便地管理注释处理器,并将它们放到注释处理器路径上。

4.构建扫描

通过对性能、依赖管理、日志记录和废弃api的使用进行新的检查,构建扫描有了显著的改进。这是一个免费的服务,提供给Gradle用户-只需添加时,在命令行上执行Gradle或应用和配置构建扫描插件。

细粒度的传递依赖关系管理

Gradle 5.0提供了几个新的特性来定制如何选择依赖项,以及改进的POM和BOM支持:

依赖约束允许您定义版本或版本范围来限制直接和传递依赖版本(Maven不支持)。

平台定义(又称Maven BOM依赖项)是本地支持的,它允许在不使用外部插件的情况下导入Spring引导平台定义之类的东西。

依赖项对齐允许逻辑组中的不同模块(例如Jackson模块)对齐到相同的版本。

现在可以锁定动态依赖项版本,以便更好地构建可重现性。

1.依赖约束

依赖约束提供了对传递依赖项的可靠控制。已声明的约束列在改进的依赖关系洞察报告和构建扫描中。

2.BOM的支持

Gradle 5.0可导入资源(BOM)文件。

此外,Gradle 5.0在使用Maven构建生成的依赖项时提供了更无缝的体验。

在使用POM文件时,Gradle将正确地分离编译和运行时范围。这避免了由于以前在编译类路径中包含运行时依赖项而导致的性能下降和依赖项泄漏。

支持在POM文件的

标签中定义版本范围

3.依赖对齐

依赖项版本对齐允许属于同一逻辑组(平台)的不同模块在依赖项图中拥有相同的版本。

这解决了确保所有Spring或Hibernate依赖项具有相同版本(如果适用)的问题。事实上,有许多库是以集合的形式发布的,集合中的每个库具有相同的版本。这个特性还有其他用例,所以请按照上面的链接从文档了解更多信息。

4.依赖版本锁定

您可以使用Gradle 5.0将动态或远程依赖项锁定到特定的版本,从而使依赖项解析更加确定和可重现。这可以防止转换依赖项的更改意外地破坏构建。

Example 1,锁定特定cofiguration

Example 2,锁定所有configuration

Example 3, 锁定buildscript classpath configuration

编写Gradle构建逻辑

现在可以用Kotlin编写Gradle构建脚本。此外,gradle init还扩展了项目类型和交互性。

1.Kotlin DSL支持

Kotlin DSL 1.0从Gradle 5.0开始就可以使用了。Kotlin中的静态类型允许工具提供更好的IDE帮助,包括调试和重构构建脚本、自动完成、错误提示和您期望的其他一切。

2.扩展和交互式 gradle init

希望创建新Gradle构建的用户可以选择其他项目类型:kotlin-library和kotlin-application。此外,您可以选择生成Groovy或Kotlin DSL构建脚本,并自定义项目名称和包。最后,一个新的交互UI让用户体验特别愉快。

3.更加可导航和面向用例的文档

更高效的内存级别执行

像和JVM应用程序的命令行参数等特性允许更好的开发工作流,同时降低内存需求和缓存清理可以减少Gradle在系统上的开销。

1.降低内存需求

升级不仅会使构建速度更快,而且还会大大减少内存的使用。许多缓存机制在Gradle 5.0中得到了优化,结果Gradle进程的默认最大内存大大减少。

2.阶段性缓存清理

手动清理Gradle缓存的日子已经结束了。Gradle现在定期清理过期缓存。Gradle还更精确地跟踪陈旧的任务输出,并且能判断出如果当前不清理可能会造成错误,进而自动进行清理。

新的Gradle调用选项

1.Testing

Gradle 5.0包括对JUnit 5的支持:JUnit平台、JUnit Jupiter和JUnit Vintage。这种支持允许您启用测试分组和筛选,并包括定制的测试引擎。

2.Logging

在Gradle 5.0中,日志消息现在按照为非交互环境(如持续集成执行)生成日志消息的任务分组。

除了显示正在执行哪些测试之外,Gradle丰富的命令行控制台还显示了一个彩色的构建状态,可以一眼看出是否有任何测试失败。您还可以要求Gradle在任务使用“详细”控制台模式执行时记录它们。

最后,通过配置警告模式,可以汇总、屏蔽或扩展Gradle警告日志。这对于将您的构建升级到5.0级非常有帮助。

3.复合构建

复合构建允许您包含其他独立项目,例如,您可以同时开发应用程序和依赖的库。

现在可以使用构建扫描检查复合构建。复合构建还与兼容。

默认情况下它们是并行构建的,现在可以嵌套了。

4.JVM应用程序的命令行参数

使用Gradle 5.0运行带有自定义参数的Java应用程序要容易得多,因为您可以在命令行上或通过IDE简单地指定它们。

新的Gradle任务和插件api

Gradle 5.0提供了许多新的api,这些api支持更快、更通用的构建逻辑。

1.Performance APIs

新的Worker API允许安全的并行和异步执行。按照我们的指南,使用Worker API为自定义任务启用更快的构建。

没有使用 Worker API 使用 Worker API

2.Improved task I/O

正确声明输入和输出对于正确的增量构建和构建缓存行为至关重要。Gradle 5.0加强了约束,并为输入/输出声明引入了新的api,这些api可以帮助您避免正确性问题。

3.避免多余配置

有些项目会产生很多很多的任务。当只执行一些操作时,配置所有这些操作是没有意义的。这就是Gradle 5.0的新配置避免api的帮助之处。通过在自定义任务中采用这些配置,大型项目可以节省高达10%的配置时间。

4.发布 APIs

Gradle 5.0引入了新的api来改进对Maven和Ivy存储库的发布:

签名插件支持对发布的所有产物签名。

发布了配置范围内的依赖项排除。

Maven发布和Ivy发布插件提供类型安全的dsl来定制作为发布的一部分生成的pom或Ivy模块。

5.Task timeouts

现在可以为任务指定超时时间,超时后任务将被中断。

6.自定义CLI 参数

Gradle 5.0提供了允许用户配置自定义任务的新方法。

首先,您可以使用创建自定义命令行选项。用户可以通过执行来发现这些问题:

7.定制嵌套dsl

为需要使用内部api的任务提供自定义的嵌套DSL。Gradle 5.0为嵌套DSL元素提供了一流的api,在考虑用户如何配置任务时提供了更大的灵活性。

Gradle 5.0为计算(或延迟)任务输入和输出提供了额外的API便利。这使得自定义任务作者能够将Gradle models连接在一起,而不用担心给定的属性值何时会被知道,也不用担心在任务配置期间会避免资源密集型工作。

如何升级

请参考如何从Gradle 4.x升级到 Gradle 5.0:

https://docs.gradle.org/5.0/userguide/upgrading_version_4.html

在升级之前,我们建议你:

用Gradle Wrapper 升级到4.10.2

运行列出所有不推荐使用的gradle api及其位置,包括插件

更新你的Gradle插件,特别是那些在构建扫描的警告报告中列出的插件

升级到JDK 8或更高版本

  • 发表于:
  • 原文链接https://kuaibao.qq.com/s/20181130G0N7IJ00?refer=cp_1026
  • 腾讯「云+社区」是腾讯内容开放平台帐号(企鹅号)传播渠道之一,根据《腾讯内容开放平台服务协议》转载发布内容。
  • 如有侵权,请联系 yunjia_community@tencent.com 删除。

扫码关注云+社区

领取腾讯云代金券